function varargout = anomalydetection(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @anomalydetection_OpeningFcn, ...
                   'gui_OutputFcn',  @anomalydetection_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before anomalydetection is made visible.
function anomalydetection_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes anomalydetection wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = anomalydetection_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function etRuta_Callback(hObject, eventdata, handles)
% hObject    handle to etRuta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of etRuta as text
%        str2double(get(hObject,'String')) returns contents of etRuta as a double


% --- Executes during object creation, after setting all properties.
function etRuta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to etRuta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in btnAbrir.
function btnAbrir_Callback(hObject, eventdata, handles)
global nombre;
global carpeta;
[nombre,carpeta]=uigetfile('*.mat');



% --- Executes on button press in btnImprimir.
function btnImprimir_Callback(hObject, eventdata, handles)
% hObject    handle to btnImprimir (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in btnCalcular.
function btnCalcular_Callback(hObject, eventdata, handles)
% Load the data.
clear; close all; clc;

fprintf('Loading data...\n');
global nombre;
global carpeta;
load(strcat(carpeta,nombre),'X','Xval','yval');

% Estimate mu and sigma2.
fprintf('Estimating mu and sigma2...\n');
[mu sigma2] = estimate_gaussian(X);

% Visualize the fit.
fprintf('Visualizing data and Gaussian distribution...\n');

[X1, X2] = meshgrid(0:.5:35); 
    Z = multivariate_gaussian([X1(:) X2(:)], mu, sigma2);
    Z = reshape(Z, size(X1));

    % Visualize training data set.
    hold on;
    axes(handles.axis);
    plot(X(:, 1), X(:, 2),'bx');
    % Do not plot if there are infinities
    if (sum(isinf(Z)) == 0)
        contour(X1, X2, Z, 10 .^ (-20:3:0)');
    end

xlabel('Latency (ms)');
ylabel('Throughput (mb/s)');
title('Servers Parameters');

% Returns the density of the multivariate normal at each data point (row) of X.
probabilities = multivariate_gaussian(X, mu, sigma2);

% Select best threshold.
fprintf('Selecting a best threshold...\n');
[epsilon F1] = select_threshold(yval, probabilities);

fprintf('Best epsilon found using cross-validation: %e\n', epsilon);
fprintf('Best F1 on Cross Validation Set:  %f\n', F1);

% Plottin outliers.
fprintf('Plottin outliers...\n');

%  Find the outliers in the training set and plot them.
outliers = find(probabilities < epsilon);

%  Draw a red circle around those outliers

hold on;
plot(X(outliers, 1), X(outliers, 2), 'ro', 'LineWidth', 2, 'MarkerSize', 10);
legend('Training set', 'Gaussian contour', 'Anomalies');
